Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.xom
Class XOMObjectModel

    java.lang.Object
      net.sf.saxon.xom.XOMObjectModel

All Implemented Interfaces:
  Serializable, ExternalObjectModel

    public class XOMObjectModel

extends Object
implements ExternalObjectModel, Serializable

This interface must be implemented by any third-party object model that can be wrapped with a wrapper that implements the Saxon Object Model (the NodeInfo interface). This implementation of the interface supports wrapping of JDOM Documents.

See Also:
  Serialized Form

Constructor Summary
`XOMObjectModel()`

Method Summary
`Value` | `convertObjectToXPathValue(Object object, Configuration config)` Convert a Java object to an XPath value.
`Object` | `convertToNodeList(SequenceExtent extent)` Convert a sequence of values to a NODELIST, as defined in the JAXP XPath API spec.
`Object` | `convertXPathValueToObject(Value value, Class targetClass, XPathContext context)` Convert an XPath value to an object in this object model.
`Receiver` | `getDocumentBuilder(Result result)` Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
`boolean` | `isRecognizedNode(Object object)` Test whether this object model recognizes a given node as one of its own
`boolean` | `isRecognizedNodeClass(Class nodeClass)` Test whether this object model recognizes a given class as representing a node in that object model.
`boolean` | `isRecognizedNodeListClass(Class nodeClass)` Test whether this object model recognizes a given class as representing a list of nodes in that object model.
`boolean` | `sendSource(Source source, Receiver receiver, PipelineConfiguration pipe)` Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
`NodeInfo` | `unravel(Source source, Configuration config)` Wrap or unwrap a node using this object model to return the corresponding Saxon node.
`DocumentInfo` | `wrapDocument(Object node, String baseURI, Configuration config)` Wrap a document node in the external object model in a document wrapper that implements the Saxon DocumentInfo interface
`NodeInfo` | `wrapNode(DocumentInfo document, Object node)` Wrap a node within the external object model in a node wrapper that implements the Saxon VirtualNode interface (which is an extension of NodeInfo)

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XOMObjectModel

    public XOMObjectModel()

Method Detail

### isRecognizedNode

    public boolean isRecognizedNode(Object object)

  Test whether this object model recognizes a given node as one of its own

  Specified by:
    `isRecognizedNode` in interface `ExternalObjectModel`
  Parameters:
    `object` - An object that possibly represents a node
  Returns:
    true if the object is a representation of a node in this object model

### isRecognizedNodeClass

    public boolean isRecognizedNodeClass(Class nodeClass)

  Test whether this object model recognizes a given class as representing a node in that object model. This method will generally be called at compile time.

  Specified by:
    `isRecognizedNodeClass` in interface `ExternalObjectModel`
  Parameters:
    `nodeClass` - A class that possibly represents nodes
  Returns:
    true if the class is used to represent nodes in this object model

### isRecognizedNodeListClass

    public boolean isRecognizedNodeListClass(Class nodeClass)

  Test whether this object model recognizes a given class as representing a list of nodes in that object model. This method will generally be called at compile time.

  Specified by:
    `isRecognizedNodeListClass` in interface `ExternalObjectModel`
  Parameters:
    `nodeClass` - A class that possibly represents nodes
  Returns:
    true if the class is used to represent nodes in this object model

### getDocumentBuilder

    public Receiver getDocumentBuilder(Result result)

  Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, return null.

  Specified by:
    `getDocumentBuilder` in interface `ExternalObjectModel`

### sendSource

    public boolean sendSource(Source source,
                              Receiver receiver,
                              PipelineConfiguration pipe)
                       throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false.

  Specified by:
    `sendSource` in interface `ExternalObjectModel`
  Throws:
    `XPathException`

### unravel

    public NodeInfo unravel(Source source,
                            Configuration config)

  Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null

  Specified by:
    `unravel` in interface `ExternalObjectModel`

### convertObjectToXPathValue

    public Value convertObjectToXPathValue(Object object,
                                           Configuration config)
                                    throws XPathException

  Convert a Java object to an XPath value. If the supplied object is recognized as a representation of a value using this object model, the object model should convert the value to an XPath value and return this as the result. If not, it should return null. If the object is recognized but cannot be converted, an exception should be thrown

  Specified by:
    `convertObjectToXPathValue` in interface `ExternalObjectModel`
  Throws:
    `XPathException`

### convertXPathValueToObject

    public Object convertXPathValueToObject(Value value,
                                            Class targetClass,
                                            XPathContext context)
                                     throws XPathException

  Convert an XPath value to an object in this object model. If the supplied value can be converted to an object in this model, of the specified class, then the conversion should be done and the resulting object returned. If the value cannot be converted, the method should return null. Note that the supplied class might be a List, in which case the method should inspect the contents of the Value to see whether they belong to this object model.

  Specified by:
    `convertXPathValueToObject` in interface `ExternalObjectModel`
  Throws:
    `XPathException` - if the target class is explicitly associated with this object model, but the supplied value cannot be converted to the appropriate class

### wrapDocument

    public DocumentInfo wrapDocument(Object node,
                                     String baseURI,
                                     Configuration config)

  Wrap a document node in the external object model in a document wrapper that implements the Saxon DocumentInfo interface

  Specified by:
    `wrapDocument` in interface `ExternalObjectModel`
  Parameters:
    `node` - a node (any node) in the third party document
    `baseURI` - the base URI of the node (supply "" if unknown)
    `config` - the Saxon configuration (which among other things provides access to the NamePool)
  Returns:
    the wrapper, which must implement DocumentInfo

### wrapNode

    public NodeInfo wrapNode(DocumentInfo document,
                             Object node)

  Wrap a node within the external object model in a node wrapper that implements the Saxon VirtualNode interface (which is an extension of NodeInfo)

  Specified by:
    `wrapNode` in interface `ExternalObjectModel`
  Parameters:
    `document` - the document wrapper, as a DocumentInfo object
    `node` - the node to be wrapped. This must be a node within the document wrapped by the DocumentInfo provided in the first argument
  Returns:
    the wrapper for the node, as an instance of VirtualNode

### convertToNodeList

    public Object convertToNodeList(SequenceExtent extent)

  Convert a sequence of values to a NODELIST, as defined in the JAXP XPath API spec. This method is used when the evaluate() request specifies the return type as NODELIST, regardless of the actual results of the expression. If the sequence contains things other than nodes, the fallback is to return the sequence as a Java List object. The method can return null to invoke fallback behaviour.

  Specified by:
    `convertToNodeList` in interface `ExternalObjectModel`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.